﻿ -- Mars-Juillet 2016
 local L = GladiatorVoiceAlerter.L
 -- GladiatorVoiceAlerter = CreateFrame("Frame", "GladiatorVoiceAlerter_MAIN_FRAME")
 local LSM = LibStub("LibSharedMedia-3.0")
---------------------------------------------------------------------------------------------------------
 local GVA_DB
---------------------------------------------------------------------------------------------------------
 local icon = LibStub("LibDBIcon-1.0")
 local bunnyLDB = LibStub("LibDataBroker-1.1"):NewDataObject("Bunnies!", {
	type = "data source",
	text = "Bunnies!",
	icon = "Interface\\AddOns\\GladiatorVoiceAlerter\\Gfx\\skull",
	OnClick = function(self, button)
				if button == "LeftButton" then
					GladiatorVoiceAlerter.MainGVAframe:Show()
					GladiatorVoiceAlerter.MainGVAframe.MainModelFrame:Show()
				elseif IsShiftKeyDown() then
					ReloadUI()
					print("Follow the red rabb... No nonono.")
				elseif button == "RightButton" then
					local FD_TitleDropDownMenu = CreateFrame("Frame", "PVA_TitleDropDownMenu", nil, "UIDropDownMenuTemplate") -- FD_TitleDropDownMenu MISTAKE
					local PVAMenuTable = {
						-- {
							-- text = TRADESKILL_POST,
							-- isTitle = 1,
							-- notCheckable = 1,
						-- },
						{
							text = "Hide Icon",
							func = function()
								GladiatorVoiceAlerter:CommandTheBunnies("toggle")
							end,
							notCheckable = 1,
						},
						{
							text = "Show Menu",
							func = function()
								GladiatorVoiceAlerter.MainGVAframe:Show()
								GladiatorVoiceAlerter.MainGVAframe.MainModelFrame:Show()
							end,
							notCheckable = 1,
						},
						}
					EasyMenu(PVAMenuTable, PVA_TitleDropDownMenu,"cursor", 0, 0, "MENU", 1)
					-- Simplified Menu Display System
					--	This is a basic system for displaying a menu from a structure table.
					--
					--	See UIDropDownMenu.lua for the menuList details.
					--
					--	Args:
					--		menuList - menu table
					--		menuFrame - the UI frame to populate
					--		anchor - where to anchor the frame (e.g. CURSOR)
					--		x - x offset
					--		y - y offset
					--		displayMode - border type
					--		autoHideDelay - how long until the menu disappears
					--
					-- function EasyMenu(menuList, menuFrame, anchor, x, y, displayMode, autoHideDelay )
				end
				end,
	OnTooltipShow = function(tooltip)
				tooltip:AddLine("Gladiator Voice Alerter",0.5,0.6,1)
				tooltip:AddLine("|c5577a55fLeft Click|r to open Menu")
				tooltip:AddLine("|c5577a55fRight Click|r for options")
				end,
 })

 local function tl(T)
	local c = 0; for _ in pairs(T) do c = c + 1 end; return c
 end

 function GladiatorVoiceAlerter:RefreshFrame()
	-- Update GVA Frame
	if GladiatorVoiceAlerter.MainGVAframe:IsShown() then
		GladiatorVoiceAlerter.MainGVAframe:Hide();
		GladiatorVoiceAlerter.MainGVAframe:Show();
	end
	-- Update Blibli Menu options
	-- if InterfaceOptionsFrame:IsShown() then
		-- InterfaceOptionsFrame:Hide() 
		-- InterfaceOptionsFrame:Show() 
	-- end
 end

 local LSM_PvPVA_SOUNDFILES = {
	["GSA-Demo"] = "Interface\\AddOns\\GladiatorVoiceAlerter\\Voice_Custom\\Will-Demo.ogg",
 }

 local GVA_VoicePack = {
	["enUS_Julie"] = {
		Nom = "English(Female)",
		Locale = "enUS",
		Chemin = "GladiatorVoiceAlerter\\Voice_enUS",
	},
	["enUS_TEST"] = {
		Nom = "English(TEST)",
		Locale = "enUS",
		Chemin = "GladiatorVoiceAlerter\\Voice_enUS",
	},
	-- ["frFR_Margaux"] = {
		-- Nom = "Francais(feminin)",
		-- Locale = "frFR",
		-- Chemin = "GVA_frFR\\Voice_frFR",
	-- },
 }
 GladiatorVoiceAlerter.GVA_VoicePack = GVA_VoicePack

 local PvPVA_EVENT = {
	SPELL_CAST_SUCCESS = 	L["Spell cast success"] or "Spell cast success",
	SPELL_CAST_START = 		L["Spell cast start"] 	or "Spell cast start",
	SPELL_AURA_APPLIED = 	L["Spell aura applied"] or "Spell aura applied",
	SPELL_AURA_REMOVED = 	L["Spell aura removed"] or "Spell aura removed",
	SPELL_INTERRUPT = 		L["Spell interrupt"] 	or "Spell interrupt",
 }
 GladiatorVoiceAlerter.PvPVA_EVENT = PvPVA_EVENT

 local PvPVA_UNIT = {
	any = 		L["Any"] 	or "Any",
	player = 	L["Player"] or "Player",
	target = 	L["Target"] or "Target",
	focus = 	L["Focus"] 	or "Focus",
	custom = 	L["Custom"] or "Custom",
 }
 GladiatorVoiceAlerter.PvPVA_UNIT = PvPVA_UNIT

---------------------------------------------------------------------------------------------------------
 local GVADB_Defaults = {
	profile = {
		DefaultVoiceSelect = 	"enUS_Julie",
		OMVoice = 				"enUS_Julie",
		ONVoice = 				"enUS_Julie",
		-- GVASpellOutDated = 		{},
		EnableGVA_ = 			true,
		MinimapIcon_ = 			true,
		Anywhere_ = 			false,
		Arena_ = 				true,
		Battleground_ = 		false,
		World_ = 				false,
		TargetAndFocusOnly_ = 	false,
		OnlyMe_ = 				false,
		EGDetect = 				false,
		EOConfig = 				false,
		CAOutput = 				"MASTER",
		-- NothingYet = 			false,
	}	
 }
 GladiatorVoiceAlerter.GVADB_Defaults = GVADB_Defaults.profile
---------------------------------------------------------------------------------------------------------
 
 GladiatorVoiceAlerter.log = function(msg) DEFAULT_CHAT_FRAME:AddMessage("|cFF33FF22GVA|r: "..msg) end

 -- LSM BEGIN / inspired from MSBTMedia.lua
 local soundz = {}
 local function RegisterSound(soundName, soundPath)
	if (type(soundName) ~= "string" or type(soundPath) ~= "string") then return end
	if (soundName == "" or soundPath == "") then return end

	soundz[soundName] = soundPath
	LSM:Register("sound", soundName, soundPath)
 end

 for soundName, soundPath in pairs(LSM_PvPVA_SOUNDFILES) do RegisterSound(soundName, soundPath) end
 for index, soundName in pairs(LSM:List("sound")) do soundz[soundName] = LSM:Fetch("sound", soundName) end

 local function LSMRegistered(event, mediaType, name)
	if (mediaType == "sound") then
		soundz[name] = LSM:Fetch(mediaType, name)
	end
 end
 -- LSM END

 local FastSpellList = { -- Finally, not so fast! Grumpf.
 SPELL_AURA_APPLIED = {},
 SPELL_AURA_REMOVED = {},
 SPELL_CAST_START = {},
 SPELL_CAST_SUCCESS = {},
 SPELL_INTERRUPT = {}
 }
 GladiatorVoiceAlerter.FastSpellList = FastSpellList
 function GladiatorVoiceAlerter:OnInitialize()
	for event,a in pairs(GladiatorVoiceAlerter.GVA_SpellList) do
		for class,b in pairs(a) do
			for spellID,fileName in pairs(b) do
				FastSpellList[event][spellID] = fileName
				if GVADB_Defaults.profile[fileName] == nil then GVADB_Defaults.profile[fileName] = true end
			end
		end
	end
---------------------------------------------------------------------------------------------------------
	GladiatorVoiceAlerter.MainDB = LibStub("AceDB-3.0"):New("GladiatorVoiceAlerter_DB",GVADB_Defaults,"Default");
	GVA_DB = GladiatorVoiceAlerter.MainDB.profile
---------------------------------------------------------------------------------------------------------
	GladiatorVoiceAlerter:CreateOptionsMenu()
 -- default bunnies
	self.db = LibStub("AceDB-3.0"):New("GVABunniesDB", {
		profile = {
			minimap = {
				hide = false,
			},
		},
	})
 -- end default bunnies
	icon:Register("Bunnies!", bunnyLDB, self.db.profile.minimap)
	LSM.RegisterCallback(LSM_PvPVA_SOUNDFILES, "LibSharedMedia_Registered", LSMRegistered)
 end

 function GladiatorVoiceAlerter:CommandTheBunnies(carrot) -- ** atm the carrot is not necessary... no rabbit in sight
	self.db.profile.minimap.hide = not self.db.profile.minimap.hide
	GVA_DB.MinimapIcon_ = self.db.profile.minimap.hide
	if self.db.profile.minimap.hide and carrot == "toggle" then
		icon:Hide("Bunnies!")
	else
		icon:Show("Bunnies!")
	end
	GladiatorVoiceAlerter:RefreshFrame()
 end

 GladiatorVoiceAlerter.Event = CreateFrame("Frame", "GladiatorVoiceAlerter_Register_Event")
 function GladiatorVoiceAlerter:OnEnable()
	GladiatorVoiceAlerter.Event:RegisterEvent("UNIT_AURA")
	GladiatorVoiceAlerter.Event:RegisterEvent("PLAYER_ENTERING_WORLD")
	GladiatorVoiceAlerter.Event:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
 end

 SLASH_GLADIATORVOICEALERTER1, SLASH_GLADIATORVOICEALERTER2 = '/gva', '/gladiatorvoicealerter';
 local function handler(msg, editbox)
	if msg == "help" or msg == "options" or msg == "?" or msg == '' then
		GladiatorVoiceAlerter.log("|cffffdd11/gladiatorvoicealerter /gva|r")
		GladiatorVoiceAlerter.log("Usage: /gva <options>")
		GladiatorVoiceAlerter.log("Options:")
		GladiatorVoiceAlerter.log("  |cffffdd11help|r or |cffffdd11?|r or nothing : This menu")
		GladiatorVoiceAlerter.log("  |cffffdd11on|r : Enable GVA")
		GladiatorVoiceAlerter.log("  |cffffdd11off|r : Disable GVA")
		GladiatorVoiceAlerter.log("  |cffffdd11menu|r : GVA menu")
		GladiatorVoiceAlerter.log("  |cffffdd11minimap|r : Show/Hide minimap icon")
		GladiatorVoiceAlerter.log("  |cffffdd11resetpos|r : Reset the main frame position(Reload the UI)")
	elseif msg == 'on' then
		GladiatorVoiceAlerter.log("Enabled")
		GVA_DB.EnableGVA_ = true
		PlaySoundKitID(7645)
	elseif msg == 'off' then
		GVA_DB.EnableGVA_ = false
		GladiatorVoiceAlerter.log("Disabled")
		PlaySoundKitID(19242,"SFX",false)
	elseif msg == 'menu' then
		GladiatorVoiceAlerter.MainGVAframe:Show()
		GladiatorVoiceAlerter.MainGVAframe.MainModelFrame:Show()
	elseif msg == 'minimap' then
		GladiatorVoiceAlerter:CommandTheBunnies("toggle")
	elseif msg == "resetpos" then
		GladiatorVoiceAlerter.MainGVAframe:SetPoint("TOPLEFT")
		ReloadUI()
	end
	GladiatorVoiceAlerter:RefreshFrame()
 end
 SlashCmdList["GLADIATORVOICEALERTER"] = handler

 function GladiatorVoiceAlerter:OnDisable()
 end

 local LanguagePath = {}
 GladiatorVoiceAlerter.LanguagePath = LanguagePath
 for Locale,a in pairs(GladiatorVoiceAlerter.GVA_VoicePack) do
	for k,v in pairs(a) do
		if k == "Chemin" then
			LanguagePath[Locale] = v
		end
	end
 end

 function GladiatorVoiceAlerter:GetGenderPath(g)
	if 		g == 1 then return LanguagePath[GVA_DB.ONVoice]
	elseif 	g == 2 then return LanguagePath[GVA_DB.OMVoice]
	else 				return LanguagePath[GVA_DB.DefaultVoiceSelect]
	end
 end

 function GladiatorVoiceAlerter:PlaySound(fileName, gender)
	local gender_path = GladiatorVoiceAlerter:GetGenderPath(gender)
	local Output = "MASTER"
	if GVA_DB.EOConfig then Output = GVA_DB.CAOutput end --                  \/ same
	if GVA_DB[fileName] == "short" then fileName = fileName.."_s" end -- SPARADRA ! Need faster call
	PlaySoundFile("Interface\\Addons\\"..gender_path.."\\"..fileName..".ogg", Output)
 end

 function GladiatorVoiceAlerter:PlaySpell(event, spellID, sourceGUID, destGUID, ...)
	local RememberMe = GladiatorVoiceAlerter.RememberMe
	if not GVA_DB[FastSpellList[event][spellID]] then return end

	local gender
	if GVA_DB.EGDetect then
		if (sourceGUID ~= nil or destGUID ~= nil) then
			if RememberMe[destGUID] or RememberMe[sourceGUID] then
				gender = RememberMe[destGUID] or RememberMe[sourceGUID]
			else
				if (sourceGUID == ('') or sourceGUID == nil ) then
					local _, _, _, _, sex, _, _ = GetPlayerInfoByGUID(destGUID)
					RememberMe[destGUID] = sex
					gender = sex
				else
					local _, _, _, _, sex, _, _ = GetPlayerInfoByGUID(sourceGUID)
					RememberMe[sourceGUID] = sex
					gender = sex
				end
				-- if tl(RememberMe) >= 1000 then GladiatorVoiceAlerter.RememberMe = {} end -- Security purge if needed : need test
			end
		else
			GladiatorVoiceAlerter.log ("sourceGUID or destGUID error")
			print("--",sourceGUID,destGUID,event,spellID)
		end
	end
		GladiatorVoiceAlerter:PlaySound(FastSpellList[event][spellID],gender)
 end

 local HolaDuCalme = {} --{[L'excité} = dernier cri}
 local sourceuid,destuid = {},{}
 -- GladiatorVoiceAlerter.sourceuid = sourceuid
 -- GladiatorVoiceAlerter.destuid = destuid
 GladiatorVoiceAlerter.Event:SetScript("OnEvent", function(self, GlobalEvent, ...)

	---- [["PLAYER_ENTERING_WORLD"]] ----
	if GlobalEvent == "PLAYER_ENTERING_WORLD" then
		GladiatorVoiceAlerter.RememberMe = {}

	---- [["UNIT_AURA"]] ----
	elseif GlobalEvent == "UNIT_AURA" then
		local uid = select (1 , ...)
		local ActualTime = GetTime()

		local focusrage = GetSpellInfo(204488) -- Test
		local name,_,_,count = UnitAura(uid,focusrage)
		if HolaDuCalme[focusrage] == nil then HolaDuCalme[focusrage] = 0 end
		if count == 3 and focusrage and (ActualTime - HolaDuCalme[focusrage]) > 5 then
			GladiatorVoiceAlerter:PlaySound("FocusedRage")
			HolaDuCalme[focusrage] = ActualTime
		end

-- local a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r = UnitAura(uid,focusrage)
-- print("|cffff1111A|r",a,"|cffff1111B|r",b,"|cffff1111C|r",c,"|cffff1111D|r",d,"|cffff1111E|r",e,"|cffff1111F|r",f,"|cffff1111G|r",g,"|cffff1111H|r",h,"|cffff1111I|r",i,"|cffff1111J|r",j,"|cffff1111K|r",k,"|cffff1111L|r",l,"|cffff1111M|r",m,"|cffff1111N|r",n,"|cffff1111O|r",o,"|cffff1111P|r",p,"|cffff1111Q|r",q,"|cffff1111R|r",r)

-- A Rage concentrée B  C Interface\Icons\Ability_Warrior_FocusedRage D 1 E nil F 30 G 467868.667 H player I false J false K 204488 L true M false N true O false P 1 Q 50 R 0
-- A Rage concentrée B  C Interface\Icons\Ability_Warrior_FocusedRage D 2 E nil F 30 G 467870.051 H player I false J false K 204488 L true M false N true O false P 1 Q 100 R 0
-- A Rage concentrée B  C Interface\Icons\Ability_Warrior_FocusedRage D 3 E nil F 30 G 467871.683 H player I false J false K 204488 L true M false N true O false P 1 Q 150 R 0
-- name,_,		icon, count, nil,			duration, 	467868.667, 	Unit, 		false, 			false, 				spellID, true, false, true, false, 1, %damage, 0
-- name,rank, 	icon, count, debuffType, 	duration, 	expirationTime, unitCaster, isStealable, 	shouldConsolidate, 	spellId  = UnitAura.. -- http://wowwiki.wikia.com/wiki/API_UnitAura


		if uid:find("arena") and GVA_DB.drinking then
			local DRINK_SPELL, REFRESHMENT_SPELL, FOOD_SPELL = GetSpellInfo(104270), GetSpellInfo(167152), GetSpellInfo(5006)
			if UnitAura(uid,DRINK_SPELL) or UnitAura(uid,REFRESHMENT_SPELL) or UnitAura(uid,FOOD_SPELL) then
				local gender
				if GVA_DB.EGDetect then
					gender = UnitSex(uid)
				end
				GladiatorVoiceAlerter:PlaySound("drinking",gender)
			end
		end

	---- [["COMBAT_LOG_EVENT_UNFILTERED"]] ----
	elseif GlobalEvent == "COMBAT_LOG_EVENT_UNFILTERED" then
		if not GVA_DB.EnableGVA_ then return end
		local _,currentZoneType = IsInInstance()
		if (not ((currentZoneType == "none" and GVA_DB.World_) or (currentZoneType == "pvp" and GVA_DB.Battleground_) or (currentZoneType == "arena" and GVA_DB.Arena_) or GVA_DB.Anywhere_)) then return end
		local timestamp,event,hideCaster,sourceGUID,sourceName,sourceFlags,sourceFlags2,destGUID,destName,destFlags,destFlags2,spellID,spellName = select (1,...) -- Last : Multiple de 2 <= 64 or nil : utilité ? ( SWING_MISS, UNIT_DIED, nil )
		if not PvPVA_EVENT[event] then return end
		if not CombatLog_Object_IsA(destFlags,COMBATLOG_FILTER_HOSTILE_PLAYERS) then return end
		-- if not CombatLog_Object_IsA(destFlags,COMBATLOG_FILTER_EVERYTHING) then return end


		if (destGUID) then
			for k in pairs(PvPVA_UNIT) do destuid[k] = (UnitGUID(k) == destGUID) end
		else
			print("NO destGUID",sourceName,spellName)
			for k in pairs(PvPVA_UNIT) do destuid[k] = nil end
		end
		destuid.any = true

		if (sourceGUID) then
			for k in pairs(PvPVA_UNIT) do sourceuid[k] = (UnitGUID(k) == sourceGUID) end
		else
			print("NO sourceGUID",sourceName,spellName)
			for k in pairs(PvPVA_UNIT) do sourceuid[k] = nil end
		end
		sourceuid.any = true

		-- if GVA_DB.OnlyMe_ and (event == "SPELL_CAST_SUCCESS") and FastSpellList["SPELL_CAST_START"][spellID] then event = "SPELL_CAST_START" end -- Tentative de scotch : pas terrible
		-- if GVA_DB.OnlyMe_ and not destuid.player then return end -- May occur some cast not working (spellcaststart)

		if (not GVA_DB.TargetAndFocusOnly_ or destuid.target or destuid.focus) or (not GVA_DB.TargetAndFocusOnly_ or sourceuid.target or sourceuid.focus)
		then GladiatorVoiceAlerter:PlaySpell(event, spellID, sourceGUID, destGUID) end

	end
 end)

 --  SADLY, DONT WORKS... Need investigate CheckInteractDistance
 -- ~= 60 Ft FAR 50031 50851 52833 56847 56576 58935 55050 58177 58967 58203 58502 CLOSE
 -- local itemTest = {50031,50851,52833,56847,56576,58935,55050,58177,58967,58203,58502}
 -- function GladiatorVoiceAlerter:CheckRange()
	-- local range = gvadb.range
	-- local hasRange = IsItemInRange(range,"any")
	-- if hasRange then
	-- end
 -- end